#ifndef MENU_H
#define MENU_H

#include "list.h"

#define MENU_HEAD(name) LIST_HEAD(name)

typedef struct list_head	menu_head_s;
typedef struct menu			menu_s;
typedef int (*menu_do_f)(void* arg);

struct menu
{
	char				name[100];		//
	int					index;			//
	menu_s*				parent;			//˵
	menu_do_f			do_menu;		//ѡʱĴ
	void*				arg;			//Ĳ

	menu_s*				__item_arr;		//Ӳ˵ݵַģʹá
	int					__item_cnt;		//Ӳ˵
	menu_head_s			__list;
};

void	menu_init(menu_s* menu);
int		menu_add_item(menu_s* menu, menu_s* item, menu_head_s* head);
int		menu_add_item_arr(menu_s* menu, menu_s* item_arr, int item_cnt);	//Ӳ˵ڴַʱʹӺ
menu_s*	menu_get_item(menu_s* menu, int index, menu_head_s* head);
menu_s* menu_get_item_arr(menu_s* menu, menu_s** item_arr, int* item_cnt);
int		menu_get_item_count(menu_s* menu);

#endif