#ifndef CMD_H
#define CMD_H

#define Struct_Section __attribute__ ((unused,section(".user_cmd")))

typedef struct cmd_tbl
{
	char*	name;			/* Command Name			*/
	int		max_arg_cnt;	/* maximum number of arguments	*/
	int		repeatable;		//Ƿظظָһ´ûسٴ
	int		(*do_cmd)(struct cmd_tbl *, int, int, char * const []);
	char*	usage;			/* Usage message	(short)	*/
	char*	help;			/* Help  message	(long)	*/
}cmd_tbl_s;

#define USER_CMD(name,max_arg_cnt,rep,do_cmd,usage,help) \
	cmd_tbl_s __user_cmd_##name Struct_Section = \
	{#name, max_arg_cnt, rep, do_cmd, usage, help}

extern cmd_tbl_s*	cmd_find_from_table(const char* cmd, cmd_tbl_s* table, int table_len);	//ӱѰ
extern cmd_tbl_s*	cmd_find(const char* cmd);												//Ѱ
extern int			cmd_main_loop(void);													//ѭ
extern int			cmd_print_usage(cmd_tbl_s *cmdtp);										//ӡ
extern int			cmd_run(const char* cmd, int flag);										//ִ
extern char*		readline(const char* promt);											//һ

#endif