#ifndef XARRAY_H
#define XARRAY_H

#include "../global.h"

typedef enum
{
	ARR_STATE_USER_CREATE			= 0x4,		//ûָ룬ϵͳԶ
}X_ENUM_ARR_STATE;

typedef enum
{
	ARR_MODE_CREATE_USER			= 0x1,		//ûָ
	ARR_MODE_CREATE_SYS				= 0x2       //ϵͳԶ
}ENUM_ARR_CREATE_MODE;

typedef struct array				array_s;

struct array
{
	void*		__obj_arr;		//
	uint		__obj_size;		//ռС
	uint		__count;		//

	uint		__state;		//ǰ״̬
};

void    arr_init(array_s* arr);															//ʼ
void	arr_destroy(array_s* arr);														//ͷ

bool	arr_create(array_s* arr, void* obj_arr, int obj_size, int count, int mode);		//
					
int		arr_add(array_s* arr, const void* src_obj, int count);							//ĩβ
int		arr_insert(array_s* arr, const void* src_obj, int count, int index);			//
void	arr_remove(array_s* arr, int index, int count);									//Ƴ
void	arr_remove_all(array_s* arr);													//Ƴ

int		arr_get_at(array_s* arr, void* dst_obj, int count, int index);					//öֵ 
void*	arr_get_obj_ptr(array_s* arr, int index);										//öָ
int		arr_get_count(array_s* arr);													//ö

bool	arr_is_empty(array_s* arr);														//ǷΪ
bool	arr_is_valid(array_s* arr);														//ǷЧ

#endif