
/*************************************************
* FILE         : XFunc.h
* VERSION      : 10.04.19
* AUTHOR       : XuanLin
* DATE - TIME  : 2010.03.29

* QQ           : 253892573
* MAIL         : 253892573@qq.com

A cross-platform function.
**************************************************/
#ifndef XFUNC_H
#define XFUNC_H

#include "def.h"
#include "type.h"

int		x_atoh(uchar* dst, const char* src, int len);
int		x_bcdtoh(uchar* dst, const uchar* src, int len);
char*	x_htoa(char* dst, const uchar* src, int len);
int		x_htobcd(uchar* dst, const uchar* src, int len);
char*	x_itoa(char* dst, int value, uint radix);

int		x_get_bit(int src, uint bit, uint radix);
int		x_set_bit(int src, uint value, uint bit, uint radix);

//void	x_swap(void* dst, void* dst);

#endif
