#include <string.h>
#include <stdio.h>
#include <test/test_func.h>

#define	MAX_COUNT_EXAMPLE_1		100

static test_item_s				test_func[MAX_COUNT_EXAMPLE_1];
static int						func_count = 0;

static int test_example_1_hello(void* arg)
{
	printf("example_1: hello everybody!\n");

	return PASS;
}

static int test_example_1_hello_world(void* arg)
{
	printf("example_1: hello world!\n");

	return PASS;
}

static void file_add_func(const char* name, test_do_f test, const char* menu_name)
{
	if(func_count >= MAX_COUNT_EXAMPLE_1)
	{
		printf("Can't add more function!\n");
		return;
	}

	test_init_func(test_func + func_count, name, test, menu_name, NULL);
	func_count++;
}

void file_example_1_init(test_item_s* parent)
{
	memset(test_func, 0, sizeof(test_item_s) * MAX_COUNT_EXAMPLE_1);

	file_add_func("example_1_hello", test_example_1_hello, NULL);
	file_add_func("example_1_hello_world", test_example_1_hello_world, NULL);

	if(parent)
	{
		test_add_sub_item(parent, test_func, func_count);
	}
}
